## Bbilioteca  gnuplot.py
# -*- coding: utf-8 -*-
print " "
print " "
print "============================================================"
print "			Os direitos do autor e a GPL  "
print "============================================================"
print "  "
print "Este programa é distribuido sob GPL. "
print "Se você não souber o que é a GPL, envie um e-mail ao autor "
print "                   tarcisio@member.ams.org "
print "mas em suma  quer dizer que você pode usar livremente o sistema"
print "de programas aqui mencionados, desde que esta informação seja mantida"
print "em todas as alterações que você fizer dos programas e das cópias que "
print "você deles fizer - é a proteção do direito autoral que não lhe impede"
print "de usar livremente o conhecimento mas que mantém na memória  quem "
print "participou de sua produção."
print "Este programa foi escrito por Tarcisio Praciano-Pereira "
print "professor da Universidade Estadual Vale do Acaraú - UeVA "
print "Laboratório de Matemática Computacional - Curso de Computação "
print "Sobral - Ceará - Brasil " 
print " "
print "============================================================"
print "			Author rights and  GPL  "
print "============================================================"
print "  "
print "This program is licenced under  GPL any version. "
print "If you do not know what is GPL, send and e-mail to the author "
print "                   tarcisio@member.ams.org "
print "mas shortly it means that you may use the program freely "
print "provided that this information is maintained in the program and any of its copies"
print "as well as in any changes you may do at the programs or copies of them "
print "This is the protection of the rights of the author, it will not impeach you"
print "to use freely this work but will protect the the memory of those that have done it."
print "This program has been written by Tarcisio Praciano-Pereira "
print "professor of the  Universidade Estadual Vale do Acaraú - UeVA "
print "Laboratório de Matemática Computacional - Curso de Computação "
print "Sobral - Ceará - Brasil " 


## Funções de comunicação com gnuplot
## grafunN(), cria_dadosN(), cria_transfereN()  - N \in {1,2,3,4,5}
## grafun(f, inicio, fim, n, mensagem):
## min_Max = cria_dados(f,inicio, fim,n):
## cria_transfere(f,inicio,fim,min_Max, mensagem):
## Aveiro, Monday, June 25 2012 - modificada nesta data 
## Sobral, Thursday, September 12 2013

## Bibliotecas do sistema
import sys
from posix import popen 
## from math import *
## from ambiente import *
## from  edo_splines_02 import * ## importando as funções definidas
## from biblioteca import *
## ambi=ambiente();

##  ###############   Projeto   ######################
## devolve o vetor Norma = [Max1, Max2] = [Norma[0], Norma[1]]
## Notação em ODEWithPython02.tex possivelmente
## vou considerar dois pares 
##    (f1(x),f2(x)) =  (f(x), R_PU_f(x)) =  (f(x), Riem(PU_f,-10,x)) 
##    (f3(x),f4(x)) =  (f'(x),Dif(x,R_PU_f) 
##    Norma = [Max1, Max2];  Max1  = ||f1-f2||,  Max2 = || f3-f4||
## Vou especializar este operador para calcular a soma das normas
## infinito de cada um dos pares acima

## para funções f1,f2,f3,  com precisão n, mensagem = texto
def grafun4(f1, f2, f3,  f4, inicio, fim, n, mensagem):
	Norma = cria_dados4(f1, f2, f3, f4,  inicio,fim,n);
	cria_transfere4(f1, f2, f3, f4,  inicio,fim, Norma,mensagem);
	popen("gnuplot transfere4");	
	print "A norma calculada é  ", Norma[0] + Norma[1]," =  ",  Norma[2];
	print "O valor da norma está em transfere4";


def cria_dados4(f1, f2,f3,  f4, inicio, fim,n):
	Max1, Max2, soma =  0.0, 0.0, 0.0; y1,y2,y3,y4  = 0, 0, 0, 0; ## local variables
	passo = float(fim-inicio)/n;           ## precisão do gráfico
	dados1 = open('dados1','w');
	dados2 = open('dados2','w');
	dados3 = open('dados3','w');
	dados4 = open('dados4','w');
	##  pega o valor inicial do tempo;
	## Imprime a integral acumulada "int_acum" de df	
	x=inicio; ##          a = x-delta/2;
	while x <= fim:
		##dados.write(str(x)+" "+str(convolucao(chi,chi,x))+"\n")
		##dados.write(str(x)+" "+str(soma_atom(f,x,par,a,delta))+"\n");
		y1, y2, y3, y4  =  f1(x), f2(x), f3(x), f4(x); 
		Norma = [abs(y1-y2), abs(y3-y4)]; ## no ponto x
		if Max1 < Norma[0]: Max1 = Norma[0];
		if Max2 < Norma[1]: Max2 = Norma[1];   
		soma += Max1 + Max2;
		dados1.write(str(x)+" "+str(y1)+"\n");
		dados2.write(str(x)+" "+str(y2)+"\n");
		dados3.write(str(x)+" "+str(y3)+"\n");
		dados4.write(str(x)+" "+str(y4)+"\n");
		x = x+passo; 
	## imprime linhas em branco para forçar Gnuplot a trocar as cores
	dados1.close(); dados2.close(); 
	dados3.close();	dados4.close();
	Norma = [Max1, Max2, soma];
	return Norma;


## colega de cria_dados, para uma função f qualquer, como precisão n
## cria um arquivo de comunicação com gnuplot
## mensagem é a equação da função cujo gráfico será feito
def cria_transfere4(f1, f2, f3, f4, inicio,fim, Norma, mensagem):
	transfere = open("transfere4","w");
	transfere.write( "-persist \n");
	transfere.write( "## Norma = || %f , %f || = %f\n"\
	              %(Norma[0], Norma[1], Norma[0]+ Norma[1]));
	transfere.write( "load \"funcoes.gnuplot\"  \n");
	transfere.write( "set pointsize 0.1 \n");
	transfere.write( "set xrange [%f:%f] \n"  %(inicio, fim));
	transfere.write( "set title \""+str(mensagem)+"\"  \n");
	transfere.write( "## set terminal postscript  eps enhanced color  \n");
	transfere.write( "## set output \"spline_03.eps\" \n");
	transfere.write( "plot %f,\"dados1\" with lines,\
			 \"dados2\"  with lines,\
			 \"dados3\"  with lines,\
			 \"dados4\"  with lines,\
			  %f, %f  \n" %(0, Norma[0], Norma[1]));
	transfere.write( "pause -2 \"Aperte enter para terminar\" \n");
	transfere.close();




## end of file gnuplotArtigo.py - biblioteca de funções para gnuplot
